// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2beta1/agent.proto
// Original file comments:
// Copyright 2019 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fagent_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fagent_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2beta1/agent.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/method_handler_impl.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc_impl {
class CompletionQueue;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc_impl

namespace grpc {
namespace experimental {
template <typename RequestT, typename ResponseT>
class MessageAllocator;
}  // namespace experimental
}  // namespace grpc

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2beta1 {

// Agents are best described as Natural Language Understanding (NLU) modules
// that transform user requests into actionable data. You can include agents
// in your app, product, or service to determine user intent and respond to the
// user in a natural way.
//
// After you create an agent, you can add [Intents][google.cloud.dialogflow.v2beta1.Intents], [Contexts][google.cloud.dialogflow.v2beta1.Contexts],
// [Entity Types][google.cloud.dialogflow.v2beta1.EntityTypes], [Webhooks][google.cloud.dialogflow.v2beta1.WebhookRequest], and so on to
// manage the flow of a conversation and match user input to predefined intents
// and actions.
//
// You can create an agent using both Dialogflow Standard Edition and
// Dialogflow Enterprise Edition. For details, see
// [Dialogflow
// Editions](https://cloud.google.com/dialogflow/docs/editions).
//
// You can save your agent for backup or versioning by exporting the agent by
// using the [ExportAgent][google.cloud.dialogflow.v2beta1.Agents.ExportAgent] method. You can import a saved
// agent by using the [ImportAgent][google.cloud.dialogflow.v2beta1.Agents.ImportAgent] method.
//
// Dialogflow provides several
// [prebuilt
// agents](https://cloud.google.com/dialogflow/docs/agents-prebuilt)
// for common conversation scenarios such as determining a date and time,
// converting currency, and so on.
//
// For more information about agents, see the
// [Dialogflow
// documentation](https://cloud.google.com/dialogflow/docs/agents-overview).
class Agents final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2beta1.Agents";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Retrieves the specified agent.
    virtual ::grpc::Status GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::google::cloud::dialogflow::v2beta1::Agent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>> AsyncGetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>>(AsyncGetAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>> PrepareAsyncGetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>>(PrepareAsyncGetAgentRaw(context, request, cq));
    }
    // Creates/updates the specified agent.
    virtual ::grpc::Status SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::google::cloud::dialogflow::v2beta1::Agent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>> AsyncSetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>>(AsyncSetAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>> PrepareAsyncSetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>>(PrepareAsyncSetAgentRaw(context, request, cq));
    }
    // Deletes the specified agent.
    virtual ::grpc::Status DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAgentRaw(context, request, cq));
    }
    // Returns the list of agents.
    //
    // Since there is at most one conversational agent per project, this method is
    // useful primarily for listing all agents across projects the caller has
    // access to. One can achieve that with a wildcard project collection id "-".
    // Refer to [List
    // Sub-Collections](https://cloud.google.com/apis/design/design_patterns#list_sub-collections).
    virtual ::grpc::Status SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>> AsyncSearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>>(AsyncSearchAgentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>> PrepareAsyncSearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>>(PrepareAsyncSearchAgentsRaw(context, request, cq));
    }
    // Trains the specified agent.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncTrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncTrainAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncTrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncTrainAgentRaw(context, request, cq));
    }
    // Exports the specified agent to a ZIP file.
    //
    //
    // Operation <response: [ExportAgentResponse][google.cloud.dialogflow.v2beta1.ExportAgentResponse]>
    virtual ::grpc::Status ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncExportAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncExportAgentRaw(context, request, cq));
    }
    // Imports the specified agent from a ZIP file.
    //
    // Uploads new intents and entity types without deleting the existing ones.
    // Intents and entity types with the same name are replaced with the new
    // versions from ImportAgentRequest.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportAgentRaw(context, request, cq));
    }
    // Restores the specified agent from a ZIP file.
    //
    // Replaces the current agent version with a new one. All the intents and
    // entity types in the older version are deleted.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRestoreAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRestoreAgentRaw(context, request, cq));
    }
    // Gets agent validation result. Agent validation is performed during
    // training time and is updated automatically when training is completed.
    virtual ::grpc::Status GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>> AsyncGetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>>(AsyncGetValidationResultRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>> PrepareAsyncGetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>>(PrepareAsyncGetValidationResultRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      // Retrieves the specified agent.
      virtual void GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void GetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Creates/updates the specified agent.
      virtual void SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void SetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified agent.
      virtual void DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void DeleteAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Returns the list of agents.
      //
      // Since there is at most one conversational agent per project, this method is
      // useful primarily for listing all agents across projects the caller has
      // access to. One can achieve that with a wildcard project collection id "-".
      // Refer to [List
      // Sub-Collections](https://cloud.google.com/apis/design/design_patterns#list_sub-collections).
      virtual void SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchAgents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void SearchAgents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Trains the specified agent.
      //
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TrainAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void TrainAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Exports the specified agent to a ZIP file.
      //
      //
      // Operation <response: [ExportAgentResponse][google.cloud.dialogflow.v2beta1.ExportAgentResponse]>
      virtual void ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void ExportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Imports the specified agent from a ZIP file.
      //
      // Uploads new intents and entity types without deleting the existing ones.
      // Intents and entity types with the same name are replaced with the new
      // versions from ImportAgentRequest.
      //
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void ImportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Restores the specified agent from a ZIP file.
      //
      // Replaces the current agent version with a new one. All the intents and
      // entity types in the older version are deleted.
      //
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void RestoreAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Gets agent validation result. Agent validation is performed during
      // training time and is updated automatically when training is completed.
      virtual void GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetValidationResult(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void GetValidationResult(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
    };
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>* AsyncGetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>* PrepareAsyncGetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>* AsyncSetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Agent>* PrepareAsyncSetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* AsyncSearchAgentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* PrepareAsyncSearchAgentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncTrainAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncTrainAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncExportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncExportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRestoreAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRestoreAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>* AsyncGetValidationResultRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ValidationResult>* PrepareAsyncGetValidationResultRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::google::cloud::dialogflow::v2beta1::Agent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>> AsyncGetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>>(AsyncGetAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>> PrepareAsyncGetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>>(PrepareAsyncGetAgentRaw(context, request, cq));
    }
    ::grpc::Status SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::google::cloud::dialogflow::v2beta1::Agent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>> AsyncSetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>>(AsyncSetAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>> PrepareAsyncSetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>>(PrepareAsyncSetAgentRaw(context, request, cq));
    }
    ::grpc::Status DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAgentRaw(context, request, cq));
    }
    ::grpc::Status SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>> AsyncSearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>>(AsyncSearchAgentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>> PrepareAsyncSearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>>(PrepareAsyncSearchAgentsRaw(context, request, cq));
    }
    ::grpc::Status TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncTrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncTrainAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncTrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncTrainAgentRaw(context, request, cq));
    }
    ::grpc::Status ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncExportAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncExportAgentRaw(context, request, cq));
    }
    ::grpc::Status ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportAgentRaw(context, request, cq));
    }
    ::grpc::Status RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRestoreAgentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRestoreAgentRaw(context, request, cq));
    }
    ::grpc::Status GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>> AsyncGetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>>(AsyncGetValidationResultRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>> PrepareAsyncGetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>>(PrepareAsyncGetValidationResultRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) override;
      void GetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) override;
      void GetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) override;
      void SetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, std::function<void(::grpc::Status)>) override;
      void SetAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void SetAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Agent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchAgents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchAgents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void SearchAgents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TrainAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void TrainAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void TrainAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ExportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ExportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ImportAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RestoreAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RestoreAgent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void RestoreAgent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, std::function<void(::grpc::Status)>) override;
      void GetValidationResult(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, std::function<void(::grpc::Status)>) override;
      void GetValidationResult(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetValidationResult(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>* AsyncGetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>* PrepareAsyncGetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>* AsyncSetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Agent>* PrepareAsyncSetAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* AsyncSearchAgentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* PrepareAsyncSearchAgentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncTrainAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncTrainAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncExportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncExportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRestoreAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRestoreAgentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>* AsyncGetValidationResultRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ValidationResult>* PrepareAsyncGetValidationResultRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_SetAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchAgents_;
    const ::grpc::internal::RpcMethod rpcmethod_TrainAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_RestoreAgent_;
    const ::grpc::internal::RpcMethod rpcmethod_GetValidationResult_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Retrieves the specified agent.
    virtual ::grpc::Status GetAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response);
    // Creates/updates the specified agent.
    virtual ::grpc::Status SetAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::google::cloud::dialogflow::v2beta1::Agent* response);
    // Deletes the specified agent.
    virtual ::grpc::Status DeleteAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::google::protobuf::Empty* response);
    // Returns the list of agents.
    //
    // Since there is at most one conversational agent per project, this method is
    // useful primarily for listing all agents across projects the caller has
    // access to. One can achieve that with a wildcard project collection id "-".
    // Refer to [List
    // Sub-Collections](https://cloud.google.com/apis/design/design_patterns#list_sub-collections).
    virtual ::grpc::Status SearchAgents(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response);
    // Trains the specified agent.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status TrainAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::google::longrunning::Operation* response);
    // Exports the specified agent to a ZIP file.
    //
    //
    // Operation <response: [ExportAgentResponse][google.cloud.dialogflow.v2beta1.ExportAgentResponse]>
    virtual ::grpc::Status ExportAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::google::longrunning::Operation* response);
    // Imports the specified agent from a ZIP file.
    //
    // Uploads new intents and entity types without deleting the existing ones.
    // Intents and entity types with the same name are replaced with the new
    // versions from ImportAgentRequest.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status ImportAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::google::longrunning::Operation* response);
    // Restores the specified agent from a ZIP file.
    //
    // Replaces the current agent version with a new one. All the intents and
    // entity types in the older version are deleted.
    //
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status RestoreAgent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::google::longrunning::Operation* response);
    // Gets agent validation result. Agent validation is performed during
    // training time and is updated automatically when training is completed.
    virtual ::grpc::Status GetValidationResult(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::google::cloud::dialogflow::v2beta1::ValidationResult* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAgent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::Agent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetAgent() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::Agent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAgent() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchAgents() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAgents(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TrainAgent() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTrainAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportAgent() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportAgent() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RestoreAgent() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreAgent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetValidationResult() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetValidationResult(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::ValidationResult>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetAgent<WithAsyncMethod_SetAgent<WithAsyncMethod_DeleteAgent<WithAsyncMethod_SearchAgents<WithAsyncMethod_TrainAgent<WithAsyncMethod_ExportAgent<WithAsyncMethod_ImportAgent<WithAsyncMethod_RestoreAgent<WithAsyncMethod_GetValidationResult<Service > > > > > > > > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_GetAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* request,
                 ::google::cloud::dialogflow::v2beta1::Agent* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->GetAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_GetAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::GetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>*>(
          ::grpc::Service::experimental().GetHandler(0))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_SetAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::SetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* request,
                 ::google::cloud::dialogflow::v2beta1::Agent* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->SetAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_SetAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::SetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::SetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>*>(
          ::grpc::Service::experimental().GetHandler(1))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_DeleteAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest, ::google::protobuf::Empty>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* request,
                 ::google::protobuf::Empty* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->DeleteAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_DeleteAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest, ::google::protobuf::Empty>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest, ::google::protobuf::Empty>*>(
          ::grpc::Service::experimental().GetHandler(2))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_SearchAgents() {
      ::grpc::Service::experimental().MarkMethodCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* request,
                 ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->SearchAgents(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_SearchAgents(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>*>(
          ::grpc::Service::experimental().GetHandler(3))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_TrainAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::TrainAgentRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->TrainAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_TrainAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::TrainAgentRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::TrainAgentRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(4))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ExportAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ExportAgentRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->ExportAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_ExportAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::ExportAgentRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ExportAgentRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(5))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ImportAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ImportAgentRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->ImportAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_ImportAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::ImportAgentRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ImportAgentRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(6))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_RestoreAgent() {
      ::grpc::Service::experimental().MarkMethodCallback(7,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->RestoreAgent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_RestoreAgent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(7))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_GetValidationResult() {
      ::grpc::Service::experimental().MarkMethodCallback(8,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest, ::google::cloud::dialogflow::v2beta1::ValidationResult>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* request,
                 ::google::cloud::dialogflow::v2beta1::ValidationResult* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->GetValidationResult(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_GetValidationResult(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest, ::google::cloud::dialogflow::v2beta1::ValidationResult>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest, ::google::cloud::dialogflow::v2beta1::ValidationResult>*>(
          ::grpc::Service::experimental().GetHandler(8))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  typedef ExperimentalWithCallbackMethod_GetAgent<ExperimentalWithCallbackMethod_SetAgent<ExperimentalWithCallbackMethod_DeleteAgent<ExperimentalWithCallbackMethod_SearchAgents<ExperimentalWithCallbackMethod_TrainAgent<ExperimentalWithCallbackMethod_ExportAgent<ExperimentalWithCallbackMethod_ImportAgent<ExperimentalWithCallbackMethod_RestoreAgent<ExperimentalWithCallbackMethod_GetValidationResult<Service > > > > > > > > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAgent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetAgent() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAgent() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchAgents() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TrainAgent() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportAgent() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportAgent() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RestoreAgent() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetValidationResult() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAgent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetAgent() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAgent() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchAgents() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchAgents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TrainAgent() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTrainAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportAgent() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportAgent() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RestoreAgent() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRestoreAgent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetValidationResult() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetValidationResult(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_GetAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->GetAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_SetAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->SetAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void SetAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_DeleteAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->DeleteAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_SearchAgents() {
      ::grpc::Service::experimental().MarkMethodRawCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->SearchAgents(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void SearchAgents(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_TrainAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->TrainAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void TrainAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ExportAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->ExportAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ExportAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ImportAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->ImportAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ImportAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_RestoreAgent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(7,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->RestoreAgent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void RestoreAgent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_GetValidationResult() {
      ::grpc::Service::experimental().MarkMethodRawCallback(8,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->GetValidationResult(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetValidationResult(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAgent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>(std::bind(&WithStreamedUnaryMethod_GetAgent<BaseClass>::StreamedGetAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::GetAgentRequest,::google::cloud::dialogflow::v2beta1::Agent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetAgent() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::SetAgentRequest, ::google::cloud::dialogflow::v2beta1::Agent>(std::bind(&WithStreamedUnaryMethod_SetAgent<BaseClass>::StreamedSetAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_SetAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SetAgentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Agent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::SetAgentRequest,::google::cloud::dialogflow::v2beta1::Agent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAgent() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest, ::google::protobuf::Empty>(std::bind(&WithStreamedUnaryMethod_DeleteAgent<BaseClass>::StreamedDeleteAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_DeleteAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::DeleteAgentRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchAgents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchAgents() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>(std::bind(&WithStreamedUnaryMethod_SearchAgents<BaseClass>::StreamedSearchAgents, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_SearchAgents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchAgents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::SearchAgentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchAgents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::SearchAgentsRequest,::google::cloud::dialogflow::v2beta1::SearchAgentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TrainAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TrainAgent() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::TrainAgentRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_TrainAgent<BaseClass>::StreamedTrainAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_TrainAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TrainAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::TrainAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTrainAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::TrainAgentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportAgent() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::ExportAgentRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_ExportAgent<BaseClass>::StreamedExportAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ExportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ExportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::ExportAgentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportAgent() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::ImportAgentRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_ImportAgent<BaseClass>::StreamedImportAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ImportAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ImportAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::ImportAgentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RestoreAgent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RestoreAgent() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_RestoreAgent<BaseClass>::StreamedRestoreAgent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_RestoreAgent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RestoreAgent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRestoreAgent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::RestoreAgentRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetValidationResult : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetValidationResult() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest, ::google::cloud::dialogflow::v2beta1::ValidationResult>(std::bind(&WithStreamedUnaryMethod_GetValidationResult<BaseClass>::StreamedGetValidationResult, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetValidationResult() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetValidationResult(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ValidationResult* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetValidationResult(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::GetValidationResultRequest,::google::cloud::dialogflow::v2beta1::ValidationResult>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetAgent<WithStreamedUnaryMethod_SetAgent<WithStreamedUnaryMethod_DeleteAgent<WithStreamedUnaryMethod_SearchAgents<WithStreamedUnaryMethod_TrainAgent<WithStreamedUnaryMethod_ExportAgent<WithStreamedUnaryMethod_ImportAgent<WithStreamedUnaryMethod_RestoreAgent<WithStreamedUnaryMethod_GetValidationResult<Service > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetAgent<WithStreamedUnaryMethod_SetAgent<WithStreamedUnaryMethod_DeleteAgent<WithStreamedUnaryMethod_SearchAgents<WithStreamedUnaryMethod_TrainAgent<WithStreamedUnaryMethod_ExportAgent<WithStreamedUnaryMethod_ImportAgent<WithStreamedUnaryMethod_RestoreAgent<WithStreamedUnaryMethod_GetValidationResult<Service > > > > > > > > > StreamedService;
};

}  // namespace v2beta1
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fagent_2eproto__INCLUDED
