// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2beta1/entity_type.proto
// Original file comments:
// Copyright 2019 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fentity_5ftype_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fentity_5ftype_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2beta1/entity_type.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/method_handler_impl.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc_impl {
class CompletionQueue;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc_impl

namespace grpc {
namespace experimental {
template <typename RequestT, typename ResponseT>
class MessageAllocator;
}  // namespace experimental
}  // namespace grpc

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2beta1 {

// Entities are extracted from user input and represent parameters that are
// meaningful to your application. For example, a date range, a proper name
// such as a geographic location or landmark, and so on. Entities represent
// actionable data for your application.
//
// When you define an entity, you can also include synonyms that all map to
// that entity. For example, "soft drink", "soda", "pop", and so on.
//
// There are three types of entities:
//
// *   **System** - entities that are defined by the Dialogflow API for common
//     data types such as date, time, currency, and so on. A system entity is
//     represented by the `EntityType` type.
//
// *   **Developer** - entities that are defined by you that represent
//     actionable data that is meaningful to your application. For example,
//     you could define a `pizza.sauce` entity for red or white pizza sauce,
//     a `pizza.cheese` entity for the different types of cheese on a pizza,
//     a `pizza.topping` entity for different toppings, and so on. A developer
//     entity is represented by the `EntityType` type.
//
// *   **User** - entities that are built for an individual user such as
//     favorites, preferences, playlists, and so on. A user entity is
//     represented by the [SessionEntityType][google.cloud.dialogflow.v2beta1.SessionEntityType] type.
//
// For more information about entity types, see the
// [Dialogflow
// documentation](https://cloud.google.com/dialogflow/docs/entities-overview).
class EntityTypes final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2beta1.EntityTypes";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns the list of all entity types in the specified agent.
    virtual ::grpc::Status ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>> AsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>>(AsyncListEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>> PrepareAsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>>(PrepareAsyncListEntityTypesRaw(context, request, cq));
    }
    // Retrieves the specified entity type.
    virtual ::grpc::Status GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncGetEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncGetEntityTypeRaw(context, request, cq));
    }
    // Creates an entity type in the specified agent.
    virtual ::grpc::Status CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncCreateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncCreateEntityTypeRaw(context, request, cq));
    }
    // Updates the specified entity type.
    virtual ::grpc::Status UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncUpdateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncUpdateEntityTypeRaw(context, request, cq));
    }
    // Deletes the specified entity type.
    virtual ::grpc::Status DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntityTypeRaw(context, request, cq));
    }
    // Updates/Creates multiple entity types in the specified agent.
    //
    // Operation <response: [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2beta1.BatchUpdateEntityTypesResponse]>
    virtual ::grpc::Status BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    // Deletes entity types in the specified agent.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    // Creates multiple new entities in the specified entity type.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    // Updates or creates multiple entities in the specified entity type. This
    // method does not affect entities in the entity type that aren't explicitly
    // specified in the request.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    // Deletes entities in the specified entity type.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      // Returns the list of all entity types in the specified agent.
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void ListEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Retrieves the specified entity type.
      virtual void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void GetEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Creates an entity type in the specified agent.
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void CreateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Updates the specified entity type.
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void UpdateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified entity type.
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void DeleteEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Updates/Creates multiple entity types in the specified agent.
      //
      // Operation <response: [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2beta1.BatchUpdateEntityTypesResponse]>
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes entity types in the specified agent.
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Creates multiple new entities in the specified entity type.
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchCreateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Updates or creates multiple entities in the specified entity type. This
      // method does not affect entities in the entity type that aren't explicitly
      // specified in the request.
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchUpdateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes entities in the specified entity type.
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchDeleteEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
    };
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* AsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* PrepareAsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>> AsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>>(AsyncListEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>> PrepareAsyncListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>>(PrepareAsyncListEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncGetEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncGetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncGetEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncCreateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncCreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncCreateEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::google::cloud::dialogflow::v2beta1::EntityType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> AsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(AsyncUpdateEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>> PrepareAsyncUpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>>(PrepareAsyncUpdateEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteEntityTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntityTypeRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntityTypesRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchCreateEntitiesRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateEntitiesRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteEntitiesRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ListEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void GetEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void GetEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void CreateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void UpdateEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::EntityType* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteEntityType(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntityTypes(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchCreateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteEntities(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* AsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* PrepareAsyncListEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncGetEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncCreateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* AsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::EntityType>* PrepareAsyncUpdateEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteEntityTypeRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntityTypesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchCreateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteEntitiesRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEntityType_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteEntityTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateEntities_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateEntities_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteEntities_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns the list of all entity types in the specified agent.
    virtual ::grpc::Status ListEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response);
    // Retrieves the specified entity type.
    virtual ::grpc::Status GetEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response);
    // Creates an entity type in the specified agent.
    virtual ::grpc::Status CreateEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response);
    // Updates the specified entity type.
    virtual ::grpc::Status UpdateEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::google::cloud::dialogflow::v2beta1::EntityType* response);
    // Deletes the specified entity type.
    virtual ::grpc::Status DeleteEntityType(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::google::protobuf::Empty* response);
    // Updates/Creates multiple entity types in the specified agent.
    //
    // Operation <response: [BatchUpdateEntityTypesResponse][google.cloud.dialogflow.v2beta1.BatchUpdateEntityTypesResponse]>
    virtual ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::google::longrunning::Operation* response);
    // Deletes entity types in the specified agent.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::google::longrunning::Operation* response);
    // Creates multiple new entities in the specified entity type.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchCreateEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::google::longrunning::Operation* response);
    // Updates or creates multiple entities in the specified entity type. This
    // method does not affect entities in the entity type that aren't explicitly
    // specified in the request.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::google::longrunning::Operation* response);
    // Deletes entities in the specified entity type.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntityType() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::EntityType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntityType(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntityTypes(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntities(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListEntityTypes<WithAsyncMethod_GetEntityType<WithAsyncMethod_CreateEntityType<WithAsyncMethod_UpdateEntityType<WithAsyncMethod_DeleteEntityType<WithAsyncMethod_BatchUpdateEntityTypes<WithAsyncMethod_BatchDeleteEntityTypes<WithAsyncMethod_BatchCreateEntities<WithAsyncMethod_BatchUpdateEntities<WithAsyncMethod_BatchDeleteEntities<Service > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ListEntityTypes() {
      ::grpc::Service::experimental().MarkMethodCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* request,
                 ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->ListEntityTypes(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_ListEntityTypes(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>*>(
          ::grpc::Service::experimental().GetHandler(0))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_GetEntityType() {
      ::grpc::Service::experimental().MarkMethodCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* request,
                 ::google::cloud::dialogflow::v2beta1::EntityType* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->GetEntityType(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_GetEntityType(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>*>(
          ::grpc::Service::experimental().GetHandler(1))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_CreateEntityType() {
      ::grpc::Service::experimental().MarkMethodCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* request,
                 ::google::cloud::dialogflow::v2beta1::EntityType* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->CreateEntityType(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_CreateEntityType(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>*>(
          ::grpc::Service::experimental().GetHandler(2))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_UpdateEntityType() {
      ::grpc::Service::experimental().MarkMethodCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* request,
                 ::google::cloud::dialogflow::v2beta1::EntityType* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->UpdateEntityType(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_UpdateEntityType(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>*>(
          ::grpc::Service::experimental().GetHandler(3))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_DeleteEntityType() {
      ::grpc::Service::experimental().MarkMethodCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest, ::google::protobuf::Empty>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* request,
                 ::google::protobuf::Empty* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->DeleteEntityType(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_DeleteEntityType(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest, ::google::protobuf::Empty>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest, ::google::protobuf::Empty>*>(
          ::grpc::Service::experimental().GetHandler(4))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::experimental().MarkMethodCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchUpdateEntityTypes(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchUpdateEntityTypes(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(5))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::experimental().MarkMethodCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchDeleteEntityTypes(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchDeleteEntityTypes(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(6))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchCreateEntities() {
      ::grpc::Service::experimental().MarkMethodCallback(7,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchCreateEntities(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchCreateEntities(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(7))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchUpdateEntities() {
      ::grpc::Service::experimental().MarkMethodCallback(8,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchUpdateEntities(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchUpdateEntities(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(8))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchDeleteEntities() {
      ::grpc::Service::experimental().MarkMethodCallback(9,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchDeleteEntities(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchDeleteEntities(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(9))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  typedef ExperimentalWithCallbackMethod_ListEntityTypes<ExperimentalWithCallbackMethod_GetEntityType<ExperimentalWithCallbackMethod_CreateEntityType<ExperimentalWithCallbackMethod_UpdateEntityType<ExperimentalWithCallbackMethod_DeleteEntityType<ExperimentalWithCallbackMethod_BatchUpdateEntityTypes<ExperimentalWithCallbackMethod_BatchDeleteEntityTypes<ExperimentalWithCallbackMethod_BatchCreateEntities<ExperimentalWithCallbackMethod_BatchUpdateEntities<ExperimentalWithCallbackMethod_BatchDeleteEntities<Service > > > > > > > > > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntityType() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntityType() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntityType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntityTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteEntities(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ListEntityTypes() {
      ::grpc::Service::experimental().MarkMethodRawCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->ListEntityTypes(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ListEntityTypes(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_GetEntityType() {
      ::grpc::Service::experimental().MarkMethodRawCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->GetEntityType(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetEntityType(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_CreateEntityType() {
      ::grpc::Service::experimental().MarkMethodRawCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->CreateEntityType(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void CreateEntityType(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_UpdateEntityType() {
      ::grpc::Service::experimental().MarkMethodRawCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->UpdateEntityType(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void UpdateEntityType(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_DeleteEntityType() {
      ::grpc::Service::experimental().MarkMethodRawCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->DeleteEntityType(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteEntityType(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::experimental().MarkMethodRawCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchUpdateEntityTypes(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::experimental().MarkMethodRawCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchDeleteEntityTypes(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchCreateEntities() {
      ::grpc::Service::experimental().MarkMethodRawCallback(7,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchCreateEntities(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchUpdateEntities() {
      ::grpc::Service::experimental().MarkMethodRawCallback(8,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchUpdateEntities(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchDeleteEntities() {
      ::grpc::Service::experimental().MarkMethodRawCallback(9,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchDeleteEntities(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>(std::bind(&WithStreamedUnaryMethod_ListEntityTypes<BaseClass>::StreamedListEntityTypes, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ListEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::ListEntityTypesRequest,::google::cloud::dialogflow::v2beta1::ListEntityTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntityType() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(std::bind(&WithStreamedUnaryMethod_GetEntityType<BaseClass>::StreamedGetEntityType, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::GetEntityTypeRequest,::google::cloud::dialogflow::v2beta1::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntityType() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(std::bind(&WithStreamedUnaryMethod_CreateEntityType<BaseClass>::StreamedCreateEntityType, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_CreateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::CreateEntityTypeRequest,::google::cloud::dialogflow::v2beta1::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEntityType() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest, ::google::cloud::dialogflow::v2beta1::EntityType>(std::bind(&WithStreamedUnaryMethod_UpdateEntityType<BaseClass>::StreamedUpdateEntityType, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_UpdateEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::EntityType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::UpdateEntityTypeRequest,::google::cloud::dialogflow::v2beta1::EntityType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEntityType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEntityType() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest, ::google::protobuf::Empty>(std::bind(&WithStreamedUnaryMethod_DeleteEntityType<BaseClass>::StreamedDeleteEntityType, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_DeleteEntityType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEntityType(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEntityType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::DeleteEntityTypeRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchUpdateEntityTypes<BaseClass>::StreamedBatchUpdateEntityTypes, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchUpdateEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntityTypesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteEntityTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteEntityTypes() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchDeleteEntityTypes<BaseClass>::StreamedBatchDeleteEntityTypes, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchDeleteEntityTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteEntityTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteEntityTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntityTypesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateEntities() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchCreateEntities<BaseClass>::StreamedBatchCreateEntities, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchCreateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchCreateEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateEntities() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchUpdateEntities<BaseClass>::StreamedBatchUpdateEntities, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchUpdateEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchUpdateEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteEntities : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteEntities() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchDeleteEntities<BaseClass>::StreamedBatchDeleteEntities, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchDeleteEntities() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteEntities(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteEntities(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchDeleteEntitiesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListEntityTypes<WithStreamedUnaryMethod_GetEntityType<WithStreamedUnaryMethod_CreateEntityType<WithStreamedUnaryMethod_UpdateEntityType<WithStreamedUnaryMethod_DeleteEntityType<WithStreamedUnaryMethod_BatchUpdateEntityTypes<WithStreamedUnaryMethod_BatchDeleteEntityTypes<WithStreamedUnaryMethod_BatchCreateEntities<WithStreamedUnaryMethod_BatchUpdateEntities<WithStreamedUnaryMethod_BatchDeleteEntities<Service > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListEntityTypes<WithStreamedUnaryMethod_GetEntityType<WithStreamedUnaryMethod_CreateEntityType<WithStreamedUnaryMethod_UpdateEntityType<WithStreamedUnaryMethod_DeleteEntityType<WithStreamedUnaryMethod_BatchUpdateEntityTypes<WithStreamedUnaryMethod_BatchDeleteEntityTypes<WithStreamedUnaryMethod_BatchCreateEntities<WithStreamedUnaryMethod_BatchUpdateEntities<WithStreamedUnaryMethod_BatchDeleteEntities<Service > > > > > > > > > > StreamedService;
};

}  // namespace v2beta1
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fentity_5ftype_2eproto__INCLUDED
