// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2beta1/intent.proto
// Original file comments:
// Copyright 2019 Google LLC.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fintent_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fintent_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2beta1/intent.pb.h"

#include <functional>
#include <grpcpp/impl/codegen/async_generic_service.h>
#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/client_callback.h>
#include <grpcpp/impl/codegen/client_context.h>
#include <grpcpp/impl/codegen/completion_queue.h>
#include <grpcpp/impl/codegen/method_handler_impl.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/server_callback.h>
#include <grpcpp/impl/codegen/server_context.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc_impl {
class CompletionQueue;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc_impl

namespace grpc {
namespace experimental {
template <typename RequestT, typename ResponseT>
class MessageAllocator;
}  // namespace experimental
}  // namespace grpc

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2beta1 {

// An intent represents a mapping between input from a user and an action to
// be taken by your application. When you pass user input to the
// [DetectIntent][google.cloud.dialogflow.v2beta1.Sessions.DetectIntent] (or
// [StreamingDetectIntent][google.cloud.dialogflow.v2beta1.Sessions.StreamingDetectIntent]) method, the
// Dialogflow API analyzes the input and searches
// for a matching intent. If no match is found, the Dialogflow API returns a
// fallback intent (`is_fallback` = true).
//
// You can provide additional information for the Dialogflow API to use to
// match user input to an intent by adding the following to your intent.
//
// *   **Contexts** - provide additional context for intent analysis. For
//     example, if an intent is related to an object in your application that
//     plays music, you can provide a context to determine when to match the
//     intent if the user input is "turn it off". You can include a context
//     that matches the intent when there is previous user input of
//     "play music", and not when there is previous user input of
//     "turn on the light".
//
// *   **Events** - allow for matching an intent by using an event name
//     instead of user input. Your application can provide an event name and
//     related parameters to the Dialogflow API to match an intent. For
//     example, when your application starts, you can send a welcome event
//     with a user name parameter to the Dialogflow API to match an intent with
//     a personalized welcome message for the user.
//
// *   **Training phrases** - provide examples of user input to train the
//     Dialogflow API agent to better match intents.
//
// For more information about intents, see the
// [Dialogflow
// documentation](https://cloud.google.com/dialogflow/docs/intents-overview).
class Intents final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2beta1.Intents";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Returns the list of all intents in the specified agent.
    virtual ::grpc::Status ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>> AsyncListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>>(AsyncListIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>> PrepareAsyncListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>>(PrepareAsyncListIntentsRaw(context, request, cq));
    }
    // Retrieves the specified intent.
    virtual ::grpc::Status GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncGetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncGetIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncGetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncGetIntentRaw(context, request, cq));
    }
    // Creates an intent in the specified agent.
    virtual ::grpc::Status CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncCreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncCreateIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncCreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncCreateIntentRaw(context, request, cq));
    }
    // Updates the specified intent.
    virtual ::grpc::Status UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncUpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncUpdateIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncUpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncUpdateIntentRaw(context, request, cq));
    }
    // Deletes the specified intent and its direct or indirect followup intents.
    virtual ::grpc::Status DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteIntentRaw(context, request, cq));
    }
    // Updates/Creates multiple intents in the specified agent.
    //
    // Operation <response: [BatchUpdateIntentsResponse][google.cloud.dialogflow.v2beta1.BatchUpdateIntentsResponse]>
    virtual ::grpc::Status BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchUpdateIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateIntentsRaw(context, request, cq));
    }
    // Deletes intents in the specified agent.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchDeleteIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteIntentsRaw(context, request, cq));
    }
    class experimental_async_interface {
     public:
      virtual ~experimental_async_interface() {}
      // Returns the list of all intents in the specified agent.
      virtual void ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void ListIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Retrieves the specified intent.
      virtual void GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void GetIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Creates an intent in the specified agent.
      virtual void CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void CreateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Updates the specified intent.
      virtual void UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void UpdateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified intent and its direct or indirect followup intents.
      virtual void DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void DeleteIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Updates/Creates multiple intents in the specified agent.
      //
      // Operation <response: [BatchUpdateIntentsResponse][google.cloud.dialogflow.v2beta1.BatchUpdateIntentsResponse]>
      virtual void BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchUpdateIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      // Deletes intents in the specified agent.
      //
      // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
      virtual void BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
      virtual void BatchDeleteIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) = 0;
    };
    virtual class experimental_async_interface* experimental_async() { return nullptr; }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* AsyncListIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* PrepareAsyncListIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncGetIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncGetIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncCreateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncCreateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncUpdateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncUpdateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchUpdateIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchDeleteIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>> AsyncListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>>(AsyncListIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>> PrepareAsyncListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>>(PrepareAsyncListIntentsRaw(context, request, cq));
    }
    ::grpc::Status GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncGetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncGetIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncGetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncGetIntentRaw(context, request, cq));
    }
    ::grpc::Status CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncCreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncCreateIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncCreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncCreateIntentRaw(context, request, cq));
    }
    ::grpc::Status UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::google::cloud::dialogflow::v2beta1::Intent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> AsyncUpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(AsyncUpdateIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>> PrepareAsyncUpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>>(PrepareAsyncUpdateIntentRaw(context, request, cq));
    }
    ::grpc::Status DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteIntentRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteIntentRaw(context, request, cq));
    }
    ::grpc::Status BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchUpdateIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchUpdateIntentsRaw(context, request, cq));
    }
    ::grpc::Status BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchDeleteIntentsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchDeleteIntentsRaw(context, request, cq));
    }
    class experimental_async final :
      public StubInterface::experimental_async_interface {
     public:
      void ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void ListIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void GetIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void GetIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void GetIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void CreateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void CreateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void CreateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void UpdateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, std::function<void(::grpc::Status)>) override;
      void UpdateIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void UpdateIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::cloud::dialogflow::v2beta1::Intent* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteIntent(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void DeleteIntent(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::protobuf::Empty* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchUpdateIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchUpdateIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchDeleteIntents(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
      void BatchDeleteIntents(::grpc::ClientContext* context, const ::grpc::ByteBuffer* request, ::google::longrunning::Operation* response, ::grpc::experimental::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit experimental_async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class experimental_async_interface* experimental_async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class experimental_async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* AsyncListIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* PrepareAsyncListIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncGetIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncGetIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncCreateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncCreateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* AsyncUpdateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2beta1::Intent>* PrepareAsyncUpdateIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteIntentRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchUpdateIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchUpdateIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchDeleteIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchDeleteIntentsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListIntents_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteIntent_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchUpdateIntents_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchDeleteIntents_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Returns the list of all intents in the specified agent.
    virtual ::grpc::Status ListIntents(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response);
    // Retrieves the specified intent.
    virtual ::grpc::Status GetIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response);
    // Creates an intent in the specified agent.
    virtual ::grpc::Status CreateIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response);
    // Updates the specified intent.
    virtual ::grpc::Status UpdateIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::google::cloud::dialogflow::v2beta1::Intent* response);
    // Deletes the specified intent and its direct or indirect followup intents.
    virtual ::grpc::Status DeleteIntent(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::google::protobuf::Empty* response);
    // Updates/Creates multiple intents in the specified agent.
    //
    // Operation <response: [BatchUpdateIntentsResponse][google.cloud.dialogflow.v2beta1.BatchUpdateIntentsResponse]>
    virtual ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::google::longrunning::Operation* response);
    // Deletes intents in the specified agent.
    //
    // Operation <response: [google.protobuf.Empty][google.protobuf.Empty]>
    virtual ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListIntents() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIntents(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIntent() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::Intent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateIntent() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::Intent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateIntent() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2beta1::Intent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteIntent() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIntent(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchUpdateIntents() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateIntents(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchDeleteIntents() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteIntents(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListIntents<WithAsyncMethod_GetIntent<WithAsyncMethod_CreateIntent<WithAsyncMethod_UpdateIntent<WithAsyncMethod_DeleteIntent<WithAsyncMethod_BatchUpdateIntents<WithAsyncMethod_BatchDeleteIntents<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_ListIntents() {
      ::grpc::Service::experimental().MarkMethodCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListIntentsRequest, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* request,
                 ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->ListIntents(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_ListIntents(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::ListIntentsRequest, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListIntentsRequest, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>*>(
          ::grpc::Service::experimental().GetHandler(0))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_GetIntent() {
      ::grpc::Service::experimental().MarkMethodCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* request,
                 ::google::cloud::dialogflow::v2beta1::Intent* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->GetIntent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_GetIntent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::GetIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>*>(
          ::grpc::Service::experimental().GetHandler(1))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_CreateIntent() {
      ::grpc::Service::experimental().MarkMethodCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* request,
                 ::google::cloud::dialogflow::v2beta1::Intent* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->CreateIntent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_CreateIntent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::CreateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>*>(
          ::grpc::Service::experimental().GetHandler(2))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_UpdateIntent() {
      ::grpc::Service::experimental().MarkMethodCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* request,
                 ::google::cloud::dialogflow::v2beta1::Intent* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->UpdateIntent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_UpdateIntent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>*>(
          ::grpc::Service::experimental().GetHandler(3))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_DeleteIntent() {
      ::grpc::Service::experimental().MarkMethodCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest, ::google::protobuf::Empty>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* request,
                 ::google::protobuf::Empty* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->DeleteIntent(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_DeleteIntent(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest, ::google::protobuf::Empty>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest, ::google::protobuf::Empty>*>(
          ::grpc::Service::experimental().GetHandler(4))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchUpdateIntents() {
      ::grpc::Service::experimental().MarkMethodCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchUpdateIntents(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchUpdateIntents(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(5))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithCallbackMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithCallbackMethod_BatchDeleteIntents() {
      ::grpc::Service::experimental().MarkMethodCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest, ::google::longrunning::Operation>(
          [this](::grpc::ServerContext* context,
                 const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* request,
                 ::google::longrunning::Operation* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   return this->BatchDeleteIntents(context, request, response, controller);
                 }));
    }
    void SetMessageAllocatorFor_BatchDeleteIntents(
        ::grpc::experimental::MessageAllocator< ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest, ::google::longrunning::Operation>* allocator) {
      static_cast<::grpc_impl::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest, ::google::longrunning::Operation>*>(
          ::grpc::Service::experimental().GetHandler(6))
              ->SetMessageAllocator(allocator);
    }
    ~ExperimentalWithCallbackMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  typedef ExperimentalWithCallbackMethod_ListIntents<ExperimentalWithCallbackMethod_GetIntent<ExperimentalWithCallbackMethod_CreateIntent<ExperimentalWithCallbackMethod_UpdateIntent<ExperimentalWithCallbackMethod_DeleteIntent<ExperimentalWithCallbackMethod_BatchUpdateIntents<ExperimentalWithCallbackMethod_BatchDeleteIntents<Service > > > > > > > ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListIntents() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIntent() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateIntent() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateIntent() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteIntent() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchUpdateIntents() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchDeleteIntents() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListIntents() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListIntents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIntent() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateIntent() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateIntent() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteIntent() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteIntent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchUpdateIntents() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchUpdateIntents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchDeleteIntents() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchDeleteIntents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_ListIntents() {
      ::grpc::Service::experimental().MarkMethodRawCallback(0,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->ListIntents(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void ListIntents(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_GetIntent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(1,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->GetIntent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void GetIntent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_CreateIntent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(2,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->CreateIntent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void CreateIntent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_UpdateIntent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(3,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->UpdateIntent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void UpdateIntent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_DeleteIntent() {
      ::grpc::Service::experimental().MarkMethodRawCallback(4,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->DeleteIntent(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void DeleteIntent(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchUpdateIntents() {
      ::grpc::Service::experimental().MarkMethodRawCallback(5,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchUpdateIntents(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class ExperimentalWithRawCallbackMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    ExperimentalWithRawCallbackMethod_BatchDeleteIntents() {
      ::grpc::Service::experimental().MarkMethodRawCallback(6,
        new ::grpc_impl::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
          [this](::grpc::ServerContext* context,
                 const ::grpc::ByteBuffer* request,
                 ::grpc::ByteBuffer* response,
                 ::grpc::experimental::ServerCallbackRpcController* controller) {
                   this->BatchDeleteIntents(context, request, response, controller);
                 }));
    }
    ~ExperimentalWithRawCallbackMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual void BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/, ::grpc::experimental::ServerCallbackRpcController* controller) { controller->Finish(::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "")); }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListIntents() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::ListIntentsRequest, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse>(std::bind(&WithStreamedUnaryMethod_ListIntents<BaseClass>::StreamedListIntents, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ListIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::ListIntentsRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::ListIntentsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListIntents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::ListIntentsRequest,::google::cloud::dialogflow::v2beta1::ListIntentsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIntent() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::GetIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(std::bind(&WithStreamedUnaryMethod_GetIntent<BaseClass>::StreamedGetIntent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_GetIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::GetIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::GetIntentRequest,::google::cloud::dialogflow::v2beta1::Intent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateIntent() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::CreateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(std::bind(&WithStreamedUnaryMethod_CreateIntent<BaseClass>::StreamedCreateIntent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_CreateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::CreateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::CreateIntentRequest,::google::cloud::dialogflow::v2beta1::Intent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateIntent() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest, ::google::cloud::dialogflow::v2beta1::Intent>(std::bind(&WithStreamedUnaryMethod_UpdateIntent<BaseClass>::StreamedUpdateIntent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_UpdateIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest* /*request*/, ::google::cloud::dialogflow::v2beta1::Intent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::UpdateIntentRequest,::google::cloud::dialogflow::v2beta1::Intent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteIntent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteIntent() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest, ::google::protobuf::Empty>(std::bind(&WithStreamedUnaryMethod_DeleteIntent<BaseClass>::StreamedDeleteIntent, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_DeleteIntent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteIntent(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteIntent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::DeleteIntentRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchUpdateIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchUpdateIntents() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchUpdateIntents<BaseClass>::StreamedBatchUpdateIntents, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchUpdateIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchUpdateIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchUpdateIntents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchUpdateIntentsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchDeleteIntents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchDeleteIntents() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler< ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest, ::google::longrunning::Operation>(std::bind(&WithStreamedUnaryMethod_BatchDeleteIntents<BaseClass>::StreamedBatchDeleteIntents, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_BatchDeleteIntents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchDeleteIntents(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchDeleteIntents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2beta1::BatchDeleteIntentsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListIntents<WithStreamedUnaryMethod_GetIntent<WithStreamedUnaryMethod_CreateIntent<WithStreamedUnaryMethod_UpdateIntent<WithStreamedUnaryMethod_DeleteIntent<WithStreamedUnaryMethod_BatchUpdateIntents<WithStreamedUnaryMethod_BatchDeleteIntents<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListIntents<WithStreamedUnaryMethod_GetIntent<WithStreamedUnaryMethod_CreateIntent<WithStreamedUnaryMethod_UpdateIntent<WithStreamedUnaryMethod_DeleteIntent<WithStreamedUnaryMethod_BatchUpdateIntents<WithStreamedUnaryMethod_BatchDeleteIntents<Service > > > > > > > StreamedService;
};

}  // namespace v2beta1
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2beta1_2fintent_2eproto__INCLUDED
